#property copyright ""
#property link      "mail@webtemp.org"

#property indicator_chart_window

extern int MaxDistance = 10;
extern int PsychInterval = 25;
extern bool Male = true;

double Old = 0;
double P;

double GetRealPoint() {
  switch (Digits) {
    case 3: return(0.01);
    case 5: return(0.0001);
  }
  return(Point);
}

int init() {
  P = GetRealPoint();
  return(0);
}

int deinit() {
  ObjectDelete("psych_long");
  ObjectDelete("psych_short");
  return(0);
}

void SpeakPipDiff(double d) {
  string s = DoubleToStr(d / P, 0);
  if (Male) {
    PlaySound(s+".wav");
    return(0);
  }
  PlaySound(s+"a.wav");
  return(0);
}

int start() {
  double op = iOpen(NULL, PERIOD_H1, 0);
  double cl = Close[0];
  double hi = iHigh(NULL, PERIOD_H1, 0);
  double lo = iLow(NULL, PERIOD_H1, 0);
  double b1 = iClose(NULL, PERIOD_H1, 1) - iOpen(NULL, PERIOD_H1, 1);
  double short = MathFloor(op / PsychInterval / P) * PsychInterval * P;
  double long = short + PsychInterval * P;

  string n = "psych_short";
  if (b1 > 0) {
    ObjectCreate(n, OBJ_HLINE, 0, 0, 0);
    ObjectSet(n, OBJPROP_PRICE1, short);
    ObjectSet(n, OBJPROP_COLOR, Red);
  } else ObjectDelete(n);

  n = "psych_long";
  if (b1 < 0) {
    ObjectCreate(n, OBJ_HLINE, 0, 0, 0);
    ObjectSet(n, OBJPROP_PRICE1, long);
    ObjectSet(n, OBJPROP_COLOR, Lime);
  } else ObjectDelete(n);
  
  if (Old > 0) {
    if ((b1 < 0) && (cl <= long) && (hi <= long) && (long - cl <= MaxDistance * P) && (cl > Old)) SpeakPipDiff(long - cl);
    if ((b1 > 0) && (cl >= short) && (lo >= short) && (cl - short <= MaxDistance * P) && (cl < Old)) SpeakPipDiff(cl - short);
  }
  
  Old = cl;

  return(0);
}

